// crashEvoker.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "OgreRoot.h"
#include "OgreTextureManager.h"
#include "OgreTexture.h"
#include "OgreRenderWindow.h"
#include "OgreHardwarePixelBuffer.h"

using namespace Ogre;

#define CRASH_NUMBER 1

int _tmain(int argc, _TCHAR* argv[])
{
	std::string loadPostfix = ".dll";
#ifdef _DEBUG
	loadPostfix = "_d.dll";
#endif
	//
	// Initialize ogre
	//
	Root* pRoot = new Root("","","");
	
	pRoot->loadPlugin(String("RenderSystem_Direct3D9") + loadPostfix);
	pRoot->setRenderSystem(
		*(Root::getSingleton().getAvailableRenderers().begin()));
	pRoot->initialise(false);
	SceneManager* pScene = pRoot->createSceneManager(ST_GENERIC);

	//
	// create a render window
	//
	RenderWindow* pWindow1 = pRoot->createRenderWindow("wnd1",500,500,false);
	Camera* pWndCamera1 = pScene->createCamera("windowCam");
	Viewport* pWndViewport1 = pWindow1->addViewport(pWndCamera1);
	
#if CRASH_NUMBER == 1
	//
	// create a render window 2 (BEFORE DELETING RENDER WINDOW 1)
	// 
	// Notice that the size of window 2 is bigger than window 1
	// this is important for the crash
	//
	RenderWindow* pWindow2 = pRoot->createRenderWindow("wnd2",600,600,false);
	Camera* pWndCamera2 = pScene->createCamera("windowCam2");
	Viewport* pWndViewport2 = pWindow2->addViewport(pWndCamera2);
#endif

	//
	//render and then delete window 1
	//
	pWndViewport1->update();
	pWindow1->destroy();
	pScene->destroyCamera(pWndCamera1);

#if CRASH_NUMBER == 2
	//
	// create a render window 2 (AFTER DELETING RENDER WINDOW 1)
	//
	RenderWindow* pWindow2 = pRoot->createRenderWindow("wnd2",600,600,false);
	Camera* pWndCamera2 = pScene->createCamera("windowCam2");
	Viewport* pWndViewport2 = pWindow2->addViewport(pWndCamera2);
#endif

	//render window 2 
	pWndViewport2->update(); //CRASH HERE
	
}

